#include <iostream>
#include "blocks.h"
#include "system.h"
using namespace std;

void basicBlock::print() {
	gotopos(x,y);
	setcolor(type, type);
	cout << ' ';
}

int basicBlock::checkBounce(int bx, int by, int& bdir) {
	int oldbdir = bdir;
	if ((bx == x + 1) && (by == y - 1) && (bdir == 3)) { //nordst om blocket
		bdir = 2;
	} else if ((bx == x + 1) && (by == y + 1) && (bdir == 1)) { //sydst om
		bdir = 4;
	} else if ((bx == x - 1) && (by == y + 1) && (bdir == 2)) { //sydvst
		bdir = 3;
	} else if ((bx == x - 1) && (by == y - 1) && (bdir == 4)) { //nordvst
		bdir = 1;
	} else if ((bx == x) && (by == y - 1)) { //norr 
		bdir -= 2;
	} else if ((bx == x + 1) && (by == y)) { //ster
		bdir++;
	} else if ((bx == x) && (by == y + 1)) { //sder
		bdir += 2;
	} else if ((bx == x - 1) && (by == y)) { //vster
		bdir--;
	}
	return (oldbdir != bdir);
}

void basicBlock::getData(int &_x, int &_y, short &_type) {
	_x = x;
	_y = y;
	_type = type;
}

basicBlock::~basicBlock() {
	gotopos(x,y);
	setcolor(0, 0);
	cout << ' ';
}

basicBlock::basicBlock(int _x, int _y) {
	x = _x;
	y = _y;
	type = 4;
}

silverBlock::silverBlock(int _x, int _y) {
	x = _x;
	y = _y;
	type = 7;
}

goldenBlock::goldenBlock(int _x, int _y) {
	x = _x;
	y = _y;
	type = 6;
}

platinaBlock::platinaBlock(int _x, int _y) {
	x = _x;
	y = _y;
	type = 11;
}

deadBlock::deadBlock() {
	x = 0;
	y = 0;
	type = 0;
}
