#include <iostream>
#include <conio.h>
#include "ballpaddle.h"
#include "system.h"
#include "blocks.h"
using namespace std;

void printscore(int s);

int main(int argc, char *argv[])
{
	srand(time(0));
	random(1,1); //utan detta blir det frsta slumptalet nedan alltid (eller vdigt ofta) samma.
	int x = 1, y = 1, dir, px = 1, slept = 0, score = 0, balls = 4;
	//skriv ut vggar och tak
	setcolor(14,9);
	cout << " Score: 0";
	for (int t = 9; t < 71; t++) {
		cout << ' ';
	}
	cout << "Balls: 4 ";
	//definiera block
	basicBlock * block[18][5];
	for (int bx = 0; bx < 18; bx++) {
		block[bx][0] = new platinaBlock( 5 + 4 * bx, 3 );
		block[bx][0]->print();
	}
	for (int bx = 0; bx < 18; bx++) {
		block[bx][1] = new goldenBlock( 5 + 4 * bx, 5);
		block[bx][1]->print();
	}
	for (int bx = 0; bx < 18; bx++) {
		block[bx][2] = new silverBlock( 5 + 4 * bx, 7);
		block[bx][2]->print();
	}
	for (int bx = 0; bx < 18; bx++) {
		block[bx][3] = new basicBlock( 5 + 4 * bx, 10);
		block[bx][3]->print();
	}
	for (int bx = 0; bx < 18; bx++) {
		block[bx][4] = new basicBlock( 5 + 4 * bx, 12);
		block[bx][4]->print();
	}
	int c; //getch() returnerar egentligen en int...
	do {
		//skriv ut (och nollstll) "utrustning"
		x = 39;
		y = 22;
		dir = random(1,2);
		printpaddle(35, px);
		px = 35;
		moveball(x,y,0);
		setcolor(14,0);
		gotopos(34,11);
		cout << "Get ready!";
		gotopos(28,13);
		cout << "Press [ENTER] to start";
		setcolor(0,0);
		cin.get();
		gotopos(34,11);
		cout << "          ";
		gotopos(28,13);
		cout << "                      ";
		do {
			sleepm(25);
			if (kbhit()) {
				c = getch();
				if ((c == 0) || (c == 224)) {
					c = getch();
				}
				//flytta paddel
				int oldpx = px;
				switch(c) {
					case 75:
						if (px >= 1) {
							px--;
						}
						break;
					case 77:
						if (px <= 70) {
							px++;
						}
						break;
				}
				printpaddle(px,oldpx);
			}
			/* fuskkod...
			int oldpx = px;
			px = x -3;
			if (px <= 1) {
				px = 0;
			} else if (px >= 73) {
				px = 73;
			}			
			printpaddle(px,oldpx);
			//*/
			//flytta boll
			if (++slept >= 4) {
				moveball(x, y, dir);
				if (changedir(x, y, dir, px, block)) {
					score++;
				}
				slept = 0;
			}
			printscore(score); //genom att kra printscore hr slipper man "inmatningstecknet". Frga inte varfr.
		} while ((tolower(c) != 'q') && (y < 24) && (score < 198));
		if (y == 24) {
			gotopos(x, y);
			setcolor(0,0);
			cout << " ";
			gotopos (78,0);
			setcolor(14,9);
			cout << --balls;
		}
	} while ((tolower(c) != 'q') && (balls > 0) && (score < 198));
	if (score == 198) {
		printscore(200);
	}
	setcolor(14,0);
	gotopos(34,11);
	cout << "Game Over!";
	gotopos(28,13);
	cout << "Press [ENTER] to exit";
	setcolor(0,0);
	cin.get();
	return 0;
}

void printscore(int s) {
	setcolor(14,9);
	gotopos(8,0);
	cout << s << "    ";
}
