#include <iostream>
#include "ballpaddle.h"
#include "system.h"
using namespace std;

void moveball(int& x, int& y, int dir) {
	setcolor(12,0);
	gotopos(x,y);
	cout << ' ';
	switch (dir) {
		case 1:
			x--;
			y--;
			break;
		case 2:
			x++;
			y--;
			break;
		case 3:
			x--;
			y++;
			break;
		case 4:
			x++;
			y++;
			break;
	}
	gotopos(x,y);
	cout << (char)2;
}

bool changedir(int x, int y, int& dir, int px, basicBlock * block[18][5]) {
	bool onpaddle = (y == 22) && ((x >= px - 1) && (x <= px + 8)), bounce = false;
	//jdra hrn.
	if ((x == 0) && ((y == 1) || (y == 22))) {
		if ((y != 22) || (onpaddle)) {
			dir -= 3;
		}
	} else if ((x == 79) && ((y == 1) || (y == 22))) {
		if ((y != 22) || (onpaddle)) {
			dir--;
		}
	}
	//ndra bollens riktning vid vggar och tak
	if (onpaddle) { //paddeln
		dir -= 2;
	} else if (y == 1) { //tak
		dir += 2;
	} else if (x == 0) { //vnster
		dir++;
	} else if (x == 79) { //hger
		dir--;
	} else {
		for (int bl_x = 0; bl_x < 18; bl_x++) {
			for (int bl_r = 0; bl_r < 5; bl_r++) {
				if (block[bl_x][bl_r]->checkBounce(x,y, dir)) {
					int bx, by;
					short btype;
					block[bl_x][bl_r]->getData(bx, by, btype);
					switch (btype) {
						case 4:
							delete block[bl_x][bl_r];
							block[bl_x][bl_r] = new deadBlock();
							break;
						case 7:
							delete block[bl_x][bl_r];
							block[bl_x][bl_r] = new basicBlock(bx,by);
							block[bl_x][bl_r]->print();
							break;
						case 6:
							delete block[bl_x][bl_r];
							block[bl_x][bl_r] = new silverBlock(bx,by);
							block[bl_x][bl_r]->print();
							break;
						case 11:
							delete block[bl_x][bl_r];
							block[bl_x][bl_r] = new goldenBlock(bx,by);
							block[bl_x][bl_r]->print();
							break;
					}
					bounce = true;
				}
			}
		}
	}
	//fixa eventuella "fel" (it's by design...)
	while (dir < 1) {
		dir += 4;
	}
	return bounce;
}

void printpaddle(int x, int prevx) {
	setcolor(10,0);
	if (prevx != x) {
		gotopos(prevx,23);
		cout << "         ";
	}
	gotopos(x,23);
	cout << "\xDF\xDF\xDF\xDF\xDF\xDF\xDF\xDF\xDF";
}
