#ifndef _FO_blocks_h
#define _FO_blocks_h

class basicBlock {
	protected:
		int x,y;
		short type;
	public:
		basicBlock() { }; //anvnds fr subklasserna.
		basicBlock(int _x, int _y);
		~basicBlock();
		virtual int checkBounce(int bx, int by, int& bdir);
		void print();
		void getData(int &_x, int &_y, short &_type);
};


class silverBlock : public basicBlock {
	public:
		silverBlock(int _x = 0, int _y = 0);
};

class goldenBlock : public basicBlock {
	public:
		goldenBlock(int _x = 0, int _y = 0);
};

class platinaBlock : public basicBlock {
	public:
		platinaBlock(int _x = 0, int _y = 0);
};		

class deadBlock : public basicBlock {
	public:
		deadBlock();
		int checkBounce(int, int, int) { return false; }
};

#endif
